package com.bocloud.ims.interfaces.resource;

import com.bocloud.cmp.model.VdcBean;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.GridBean;
import com.bocloud.common.model.Pager;
import com.bocloud.common.model.RequestContext;
import com.bocloud.ims.entity.resource.Server;
import com.bocloud.ims.entity.resource.Vdc;

import java.util.List;

/**
 * vmware数据中心服务接口
 *
 * @author weiwei
 * @version 1.0
 * @since 2016.12.28
 */
public interface VdcService {

    /**
     * 数据中心列表
     *
     * @param pager
     * @return
     */
    BocloudResult<GridBean<Vdc>> list(Pager pager);

    /**
     * 添加
     *
     * @param vdc
     * @return
     */
    BocloudResult<Vdc> create(Vdc vdc);

    /**
     * 更新
     *
     * @param bean   基本信息
     * @param userId 操作用户ID
     * @return 操作结果
     */
    BocloudResult<Vdc> modify(VdcBean bean, Long userId);

    /**
     * 移除
     *
     * @param id     ID
     * @param userId 操作者ID
     * @return 操作结果
     */
    BocloudResult remove(Long id, Long userId);

    /**
     * 详细信息
     *
     * @param id ID
     * @return 详细信息
     */
    BocloudResult<Vdc> detail(Long id);

    /**
     * 宿主机列表
     *
     * @param id
     * @return
     */
    BocloudResult<List<Server>> listHost(Long id);

    BocloudResult syncByVdc(Long id, String type, RequestContext context);

}
